<?php

include_once (MYSQL);
include_once (dirname(__FILE__)."/localization.php");

class modules {

    function modules () {
		$this->DB = new DB;
		$this->DB->connect();
		$this->LOCALIZE = new localization;
    }
	
	function getVersion($module, $admin) {
		if ($admin) {
			$path = MODULES.$module."/admin.swf";
		} else {
			$path = MODULES.$module."/module.swf";
		}
		return is_file($path) ? filemtime($path) : 0;
	}
	
	function getModules($lang) {
		
		$lang = $this->LOCALIZE->checkLanguage($lang);
		
		$dirs = scandir(MODULES);
		for ($i=0; $i<count($dirs); $i++) {
			$className = $dirs[$i];
			$filename = MODULES.$className."/install/install.php";
			if (is_file($filename)) {
				include($filename);
				$reflectionObj = new ReflectionClass($className); 
				$class = $reflectionObj->newInstance();
				
				$getdata = $this->DB->query("SELECT id FROM modules WHERE id = '$className';");
				$install = $this->DB->get_num_rows($getdata) == 1 ? true : false;
				$settings = (is_file(MODULES.$className."/admin.swf") && $install) ? true : false;
				
				$modules[] = array('id' => $dirs[$i], 
								   'name' => $class->name[$lang], 
								   'description' => $class->description[$lang], 
								   'version' => $class->version,
								   'install' => $install,
								   'settings' => $settings);
			}
		}
		
		return $modules;
		
	}
	
	function getList($lang) {
		
		$lang = $this->LOCALIZE->checkLanguage($lang);
		$getdata = $this->DB->query("SELECT modules.id AS id, localization.$lang AS name FROM modules
                                     Inner Join localization ON CONCAT('module_', modules.id) = localization.component
                                     WHERE localization.variable = 'name';");
		while($section = $this->DB->fetch_array($getdata)) {
			$modules[] = array('id' => $section['id'], 'name' => $section['name']);
		}
		
		return $modules;
		
	}
	
	function getCount() {
		$getdata = $this->DB->query("SELECT COUNT(*) AS count FROM modules;");
		$section = $this->DB->fetch_array($getdata);
		return $section['count'];
	}
	
	function installModule($className) {
		
		$filename = MODULES.$className."/install/install.php";
		if (!is_file($filename)) return false;
		
		$getdata = $this->DB->query("SELECT id FROM modules WHERE id = '$className';");
		if ($this->DB->get_num_rows($getdata) > 0) return false;
		
		include($filename);
		$reflectionObj = new ReflectionClass($className); 
		$class = $reflectionObj->newInstance();
		
		$class->install();
		
		$version = $class->version;
		$this->DB->query("INSERT INTO modules (id, version) VALUES('$className', '$version');");
		
		$component = "module_".$className;
		$iso = $this->LOCALIZE->getLanguagesIso();
		
		$names = $class->name;
		$values = array();
		for ($i=0; $i<count($iso); $i++) {
			$values[] = array('iso' => $iso[$i], 'value' => $names[$iso[$i]]);
		}
		if (count($values) > 0) $this->LOCALIZE->addPhrase($component, "name", $values);
		
		$descriptions = $class->description;
		$values = array();
		for ($i=0; $i<count($iso); $i++) {
			$values[] = array('iso' => $iso[$i], 'value' => $descriptions[$iso[$i]]);
		}
		if (count($values) > 0) $this->LOCALIZE->addPhrase($component, "description", $values);
		
		return true;
			
	}
	
	function uninstallModule($className) {
		
		$filename = MODULES.$className."/install/install.php";
		if (!is_file($filename)) return false;
		
		include($filename);
		$reflectionObj = new ReflectionClass($className); 
		$class = $reflectionObj->newInstance();
		
		$class->uninstall();
		
		$component = "module_".$className;
		$this->DB->query("DELETE FROM modules WHERE id = '$className';");
		$this->DB->query("DELETE FROM localization WHERE component = '$component';");
		$this->DB->query("DELETE FROM configuration WHERE component = '$component';");
		
		return true;
		
	}
	
	function updateModule($className) {
		
	}
	
	function call($p, $p0 = NULL, $p1 = NULL, $p2 = NULL, $p3 = NULL, $p4 = NULL, $p5 = NULL, $p6 = NULL, $p7 = NULL, $p8 = NULL, $p9 = NULL) {
		
		$funcArgs = func_get_args();
		$targetStr = array_shift($funcArgs);
		$target = explode(".", $targetStr);
		
		$className = $target[0];
		$methodName = $target[1];
		
		$filename = MODULES.$className."/module.php";
		
		if (is_file($filename)) {
			include $filename;
		} else {
			return false;
		}

		$reflectionObj = new ReflectionClass($className); 
		$class = $reflectionObj->newInstance(); 
		
		if (count($funcArgs)) {
			return call_user_method_array($methodName, $class, $funcArgs);
		} else {
			return call_user_method($methodName, $class);
		}
		
	}
	
}

?>