<?php

include_once (MYSQL);
include_once (dirname(__FILE__)."/localization.php");
include_once (dirname(__FILE__)."/clients.php");

class rooms {

    function rooms () {     
		$this->DB = new DB;
		$this->DB->connect();
		$this->LOCALIZE = new localization;
		$this->CLIENTS = new clients;
    }
	
	function getDirections($owner_id, $c_id, $lang) {
		
		$lang = $this->LOCALIZE->checkLanguage($lang);
		
		if ($owner_id == 0) {
			$balance = 0;
			$utype = "guest";
		} else {
			$getdata = $this->DB->query("SELECT balance, utype FROM users WHERE id = '$owner_id' LIMIT 1;");
			$section = $this->DB->fetch_array($getdata);
			$balance = $section['balance'];
			$utype = $section['utype'];
		}
		
		$getdata = $this->DB->query("SELECT * FROM rooms WHERE active = '1' AND c_id = '$c_id' AND groups LIKE '%$utype%' ORDER BY rtype;");
		
		//$groups = explode(",", $section['groups']);
		
		$ctreate_translations = false;
		
		$business = $this->CLIENTS->business();
		
		if ($c_id > 0) {
			$rooms[] = array('name' => '...', 'rtype' => 'u', 'description' => $this->LOCALIZE->getPhrase('one_level_up', $lang));
		}
		
		while($section = $this->DB->fetch_array($getdata)) {
			
			$id = $section['id'];
			$rtype = $section['rtype'];
			$name = $section['name'];
			$user_count = $section['user_count'];
			$max_users = $section['max_users'];
			
			$status = "";
			$accessibility = "";
			$description = "";
			
			$add = true;
			
			switch ($rtype) {
				case "c":					
					$user_count = $this->getCategoryCount($id);
					$description = sprintf($this->LOCALIZE->getPhrase('server_category', $lang), $user_count);
					//if ($user_count < 1) $add = false;
					if ($user_count < 1) {
						$accessibility = "stop";
					} else {
						$accessibility = "play";
					}					
					$ctreate_translations = true;
					break;
				case "r":
					if ($section['password'] != "") {
						$description = sprintf($this->LOCALIZE->getPhrase('server_closed_room', $lang), $user_count, $max_users);
						$status = "closed";
					} else if ($section['payment_type'] != 0) {
						if ($section['payment_type'] == 1) {
							$description = sprintf($this->LOCALIZE->getPhrase('server_turnpike_room_1', $lang), $section['price'], $user_count, $max_users);
						} else {
							$description = sprintf($this->LOCALIZE->getPhrase('server_turnpike_room_2', $lang), $section['price'], $user_count, $max_users);
						}
						$status = "turnpike";
						$add = $business;
					} else {
						$description = sprintf($this->LOCALIZE->getPhrase('server_open_room', $lang), $user_count, $max_users);
						$status = "open";
					}	
					if ($user_count >= $max_users) {
						$accessibility = "stop";
					} else {
						$accessibility = "play";
					}
					if ($status == "turnpike" && $balance < $section['price']) $accessibility = "stop";
					if ($utype == "admin") $accessibility = "play";
					break;
				case "t":                            
					if ($section['password'] != "") {
						$description = sprintf($this->LOCALIZE->getPhrase('server_closed_translation', $lang), $user_count, $max_users);
						$status = "closed";
					} else if ($section['payment_type'] != 0) {
						if ($section['payment_type'] == 1) {
							$description = sprintf($this->LOCALIZE->getPhrase('server_turnpike_translation_1', $lang), $section['price'], $user_count, $max_users);
						} else {
							$description = sprintf($this->LOCALIZE->getPhrase('server_turnpike_translation_2', $lang), $section['price'], $user_count, $max_users);
						}
						$status = "turnpike";
						$add = $business;
					} else {
						$description = sprintf($this->LOCALIZE->getPhrase('server_open_translation', $lang), $user_count, $max_users);
						$status = "open";
					}
					if ($user_count >= $max_users or $user_count < 1) {
						$accessibility = "stop";
					} else {
						$accessibility = "play";
					}					
					if ($owner_id == $section['owner']) $accessibility = "play";
					if ($status == "turnpike" && $balance < $section['price']) $accessibility = "stop";	
					if ($utype == "admin") $accessibility = "play";
					break;
			}
			
			//if (!in_array($utype, $groups)) $accessibility = "stop";
			
			if ($add) {				
				$rooms[] = array('id' => $id, 
								 'name' => $name, 
								 'owner' => $section['owner'],
								 'rtype' => $rtype, 
								 'accessibility' => $accessibility, 
								 'status' => $status,
								 'payment_type' => $section['payment_type'],
								 'price' => $section['price'],	
								 'comment' => $section['comment'],
								 'description' => $description);
			}
			
		}
		
		
		
		$getdata = $this->DB->query("SELECT id FROM rooms WHERE owner = '$owner_id' AND c_id > 0 LIMIT 1;");
		$rows = $this->DB->get_num_rows();
		if ($rows > 0) {
			$user_translation = true;
		} else {
			$user_translation = false;
		}
		
		
		$result = array('rooms' => $rooms, 
						'ctreate_translations' => $ctreate_translations, 
						'user_translation' => $user_translation, 
						'balance' => $balance);
		
        return $result;
		
    }
	
	function getTranslationData($owner_id) {
		$getdata = $this->DB->query("SELECT * FROM rooms WHERE owner = '$owner_id' AND c_id > 0 LIMIT 1;");
		$rows = $this->DB->get_num_rows();
		if ($rows > 0) {
			$section = $this->DB->fetch_array($getdata);
			if ($section['password'] != "") {
				$status = "closed";
			} else {
				$status = "open";
			}
			return array('id' => $section['id'], 
						 'c_id' => $section['c_id'], 
						 'name' => $section['name'], 
						 'status' => $status,
						 'comment' => $section['comment'],
						 'description' => $section['description']);
		} else {
			return false;
		}
	}
	
	function getCategoryCount($id) {
		$getdata = $this->DB->query("SELECT COUNT(*) AS count FROM rooms WHERE active = '1' AND c_id = '$id';");
		$section = $this->DB->fetch_array($getdata);
		return $section['count'];
	}
	
	function getCategories() {
		$getdata = $this->DB->query("SELECT * FROM rooms WHERE active = '1' AND rtype = 'c';");
		while($section = $this->DB->fetch_array($getdata)) {
			$categories[] = array('id' => $section['id'], 'name' => $section['name']);
		}
        return $categories;
    }
	
	function getGroups($lang) {
		// 
		$groups = array();
		$names = explode(",", $this->LOCALIZE->getPhrase('server_groups', $lang));
		$groups[] = array('id' => 'guest', 'name' => $names[0], 'selected' => true);
		$groups[] = array('id' => 'user', 'name' => $names[1], 'selected' => true);
		$groups[] = array('id' => 'moderator', 'name' => $names[2], 'selected' => true);
		$groups[] = array('id' => 'admin', 'name' => $names[3], 'selected' => true);
		return $groups;
	}
	
	function getInitData($room_id, $lang) {
		$groups = $this->getGroups($lang);
		if ($room_id > 0) {
			$getdata = $this->DB->query("SELECT groups FROM rooms WHERE id = '$room_id';");
			$section = $this->DB->fetch_array($getdata);
			$roomGroups = explode(",", $section['groups']);
			for ($i=0; $i<count($groups); $i++) {
				$groups[$i]['selected'] = in_array($groups[$i]['id'], $roomGroups);
			}
		}
		return array('categories' => $this->getCategories(), 'groups' => $groups);
	}
	
	function getAdminRooms($c_id = 0, $lang) {
		
		$getdata = $this->DB->query("SELECT rooms.*, users.email FROM rooms Left Join users ON rooms.owner = users.id WHERE rooms.c_id = $c_id ORDER BY rooms.rtype ASC;");
		
		if ($c_id > 0) {
			$rooms[] = array('name' => '...', 'rtype' => 'u', 'active' => -1,'description' => $this->LOCALIZE->getPhrase('one_level_up', $lang));
		}
		
		while($section = $this->DB->fetch_array($getdata)) {
			
			if ($section['password'] != "") {
				$status = "closed";
			} else if ($section['payment_type'] != 0) {
				$status = "turnpike";
			} else {
				$status = "open";
			}
			
			$id = $section['id'];
			$rtype = $section['rtype'];
			
			if ($rtype == "c") {
				$user_count = $this->getCategoryCount($id);
				$max_users = "-";
			} else {
				$user_count = $section['user_count'];
				$max_users = $section['max_users'];
			}
			
			$rooms[] = array('id' => $id, 
							 'name' => $section['name'],
							 'owner' => $section['email'],
							 'rtype' => $rtype,
							 'user_count' => $user_count,
							 'max_users' => $max_users, 
							 'description' => $section['description'], 
							 'active' => $section['active'], 
							 'payment_type' => $section['payment_type'], 
							 'price' => $section['price'], 
							 'comment' => $section['comment'], 
							 'status' => $status);
			
		}
		
        return $rooms;
		
    }
		
	/*function getRooms() {
		
		$getdata = $this->DB->query("SELECT * FROM rooms WHERE active = '1' ORDER BY user_count DESC");
		
		while($section = $this->DB->fetch_array($getdata)) {
			
			$id = $section['id'];
			$name = $section['name'];
			$owner = $section['owner'];
			$description = $section['description'];
			
			$lock = false;
			if ($section['password'] != "") $lock = true;
			
			$user_count = $section['user_count'];
			$max_users = $section['max_users'];
			
			$name2 = $name." (".$user_count."/".$max_users.")";
			
			$rooms[] = array('id' => $id, 
							 'name' => $name, 
							 'name2' => $name2, 
							 'user_count' => $user_count,
							 'max_users' => $max_users, 
							 'owner' => $owner, 
							 'description' => $description, 
							 'lock' => $lock);
			
		}
		
        return $rooms;
		
    }*/
	
	/*function addStandartRooms($lang, $admin = false) {
		
		$getdata = $this->DB->query("SELECT $lang AS phrase FROM localization WHERE component = 'default_rooms'; ");
		
		while($section = $this->DB->fetch_array($getdata)) {
			$cp = $section['phrase'];
			$this->addStandartRoom($cp, $lang);
		}
		
		if ($admin) {
			$this->getAdminRooms();
		} else {
			return $this->getRooms($lang);
		}
		
	}*/
	
	/*private function addStandartRoom($name) {
		
		$lang = $this->LOCALIZE->checkLanguage($lang);
		
		$name = addslashes($name);
		$description = addslashes($description);
		
		$join_date = time();
		
		$this->DB->query("INSERT INTO rooms (name, rtype, active, max_users, password, description, join_date) 
						  VALUES('$name', 'r', '1', '500', '', '', '$join_date');");
		
	}*/
	
	function addRoom($params) {
		
		$name = addslashes($params['name']);
		$active = $params['active'];
		$status = $params['status'];
		$max_users = $params['max'];
		$description = addslashes($params['description']);
		$groups = $params['groups'];
		
		$lang = $this->LOCALIZE->checkLanguage($params['lang']);
		
		$join_date = time();
		
		switch ($status) {
			case "open":
				$password = "";
				$payment_type = "";
				$price = 0;
				break;
			case "closed":
				$password = isset($params['password']) ? md5($params['password']) : "";
				$payment_type = "";
				$price = 0;
				break;
			case "turnpike":
				$password = "";
				$payment_type = $params['payment_type'];
				$price = $params['price'];
				break;
		}
		
		//******* ,       
		$getdata = $this->DB->query("SELECT id FROM rooms WHERE name = '$name' LIMIT 1;");
		$section = $this->DB->fetch_array($getdata);
		$rows = $this->DB->get_num_rows();
		
		if ($rows != 0) {
			return array('valid' => false, 
						 'error' => $this->LOCALIZE->getPhrase('add_room_error_name_exists', $lang),
						 'title' => $this->LOCALIZE->getPhrase('error', $lang));
		}
		
		$this->DB->query("INSERT INTO rooms (name, rtype, payment_type, price, active, max_users, password, description, join_date, groups) 
						  VALUES('$name', 'r', '$payment_type', '$price', '$active', '$max_users', '$password', '$description', '$join_date', '$groups');");
		
		if ($params['ads'] == 1) $this->allowAdvertising($this->DB->insert_id());
		
		return array('valid' => true);
		
	}
	
	function editRoom($params) {
		
		$id = $params['id'];
		$name = addslashes($params['name']);
		$active = $params['active'];
		$status = $params['status'];
		$max_users = $params['max'];
		$description = addslashes($params['description']);
		$groups = $params['groups'];
		
		$lang = $this->LOCALIZE->checkLanguage($params['lang']);
		
		$join_date = time();
		
		switch ($status) {
			case "open":
				$password = "";
				$payment_type = "";
				$price = 0;
				break;
			case "closed":
				$password = isset($params['password']) ? md5($params['password']) : "";
				$payment_type = "";
				$price = 0;
				break;
			case "turnpike":
				$password = "";
				$payment_type = $params['payment_type'];
				$price = $params['price'];
				break;
		}
		
		//******* ,       
		$getdata = $this->DB->query("SELECT id FROM rooms WHERE name = '$name' AND id <> '$id' LIMIT 1;");
		$section = $this->DB->fetch_array($getdata);
		$rows = $this->DB->get_num_rows();
		
		if ($rows != 0) {
			return array('valid' => false, 
						 'error' => $this->LOCALIZE->getPhrase('add_room_error_name_exists', $lang),
						 'title' => $this->LOCALIZE->getPhrase('error', $lang));
		}
		
		$this->DB->query("UPDATE rooms 
		                  SET name = '$name', 
						      active = '$active', 
							  max_users = '$max_users', 
						      payment_type = '$payment_type', 
							  price = '$price', 
							  password = '$password', 
							  description = '$description',
							  groups = '$groups'
						  WHERE id = '$id';");
		
		if ($params['ads'] == 1) $this->allowAdvertising($id);
		
		return array('valid' => true);
		
	}
	
	function addTranslation($params) {
		
		$name = addslashes($params['name']);
		$owner = $params['owner'];
		$active = isset($params['active']) ? $params['active'] : 1;
		$status = $params['status'];
		$max_users = isset($params['max']) ? $params['max'] : 500;
		$description = addslashes($params['description']);
		$groups = $params['groups'];
		
		$temporary = isset($params['temporary']) ? $params['temporary'] : 0;
		$c_id = isset($params['c_id']) ? $params['c_id'] : 0;
		$comment = isset($params['comment']) ? $params['comment'] : 0;
		
		$lang = $this->LOCALIZE->checkLanguage($params['lang']);
		
		$join_date = time();
		
		switch ($status) {
			case "open":
				$password = "";
				$payment_type = "";
				$price = 0;
				break;
			case "closed":
				$password = isset($params['password']) ? md5($params['password']) : "";
				$payment_type = "";
				$price = 0;
				break;
			case "turnpike":
				$password = "";
				$payment_type = $params['payment_type'];
				$price = $params['price'];
				break;
		}
		//******* ,       
		$getdata = $this->DB->query("SELECT id FROM rooms WHERE name = '$name' LIMIT 1;");
		$rows = $this->DB->get_num_rows();
		if ($rows != 0) {
			return array('valid' => false, 
						 'error' => $this->LOCALIZE->getPhrase('add_room_error_name_exists', $lang),
						 'title' => $this->LOCALIZE->getPhrase('error', $lang));
		}
		//******* ,       
		if (!isset($params['owner_id'])) {
			$getdata = $this->DB->query("SELECT id FROM users WHERE email = '$owner' LIMIT 1;");
			$section = $this->DB->fetch_array($getdata);
			$rows = $this->DB->get_num_rows();
			if ($rows == 0) {
				return array('valid' => false, 
							 'error' => $this->LOCALIZE->getPhrase('add_room_error_not_owner', $lang),
							 'title' => $this->LOCALIZE->getPhrase('error', $lang));
			}		
			$owner_id = $section['id'];
		} else {
			$owner_id = $params['owner_id'];
		}
		
		//******* ,      
		$getdata = $this->DB->query("SELECT id FROM rooms WHERE owner = '$owner_id' LIMIT 1;");
		$rows = $this->DB->get_num_rows();
		
		if ($rows != 0) {
			return array('valid' => false, 
						 'error' => $this->LOCALIZE->getPhrase('add_room_error_already_owner', $lang),
						 'title' => $this->LOCALIZE->getPhrase('error', $lang));
		}
		
		$this->DB->query("INSERT INTO rooms (c_id, name, owner, rtype, payment_type, price, active, max_users, password, description, temporary, comment, join_date, groups) 
						  VALUES('$c_id', '$name', '$owner_id', 't', '$payment_type', '$price', '$active', '$max_users', '$password', '$description', '$temporary', '$comment', '$join_date', '$groups');");
		
		$insert_id = $this->DB->insert_id();
		$key = strtoupper(md5($insert_id . "_" . time()));
		$this->DB->query("UPDATE rooms SET `key` = '$key' WHERE id = '$insert_id' LIMIT 1;");
		
		if ($params['ads'] == 1 && $c_id == 0) $this->allowAdvertising($this->DB->insert_id());
		
		return array('valid' => true, 'id' => $this->DB->insert_id(), 'time' => $join_date);
		
	}
	
	function editTranslation($params) {
		
		$id = $params['id'];
		$name = addslashes($params['name']);
		$owner = $params['owner'];
		$active = isset($params['active']) ? $params['active'] : 1;
		$status = $params['status'];
		$max_users = isset($params['max']) ? $params['max'] : 500;
		$description = addslashes($params['description']);
		$groups = $params['groups'];
		
		$temporary = isset($params['temporary']) ? $params['temporary'] : 0;
		$c_id = isset($params['c_id']) ? $params['c_id'] : 0;
		$comment = isset($params['comment']) ? $params['comment'] : 0;
		
		$lang = $this->LOCALIZE->checkLanguage($params['lang']);
		
		$join_date = time();
		
		switch ($status) {
			case "open":
				$password = "";
				$payment_type = "";
				$price = 0;
				break;
			case "closed":
				$password = isset($params['password']) ? md5($params['password']) : "";
				$payment_type = "";
				$price = 0;
				break;
			case "turnpike":
				$password = "";
				$payment_type = $params['payment_type'];
				$price = $params['price'];
				break;
		}
		//******* ,       
		$getdata = $this->DB->query("SELECT id FROM rooms WHERE name = '$name' AND id <> '$id' LIMIT 1;");
		$rows = $this->DB->get_num_rows();
		
		if ($rows != 0) {
			return array('valid' => false, 
						 'error' => $this->LOCALIZE->getPhrase('add_room_error_name_exists', $lang),
						 'title' => $this->LOCALIZE->getPhrase('error', $lang));
		}
		//******* ,       
		if (!isset($params['owner_id'])) {
			$getdata = $this->DB->query("SELECT id FROM users WHERE email = '$owner' LIMIT 1;");
			$section = $this->DB->fetch_array($getdata);
			$rows = $this->DB->get_num_rows();
			if ($rows == 0) {
				return array('valid' => false, 
							 'error' => $this->LOCALIZE->getPhrase('add_room_error_not_owner', $lang),
							 'title' => $this->LOCALIZE->getPhrase('error', $lang));
			}
			$owner_id = $section['id'];
		} else {
			$owner_id = $params['owner_id'];
		}
		
		//******* ,      
		$getdata = $this->DB->query("SELECT id FROM rooms WHERE owner = '$owner_id' AND id <> '$id' LIMIT 1;");
		$rows = $this->DB->get_num_rows();
		
		if ($rows != 0) {
			return array('valid' => false, 
						 'error' => $this->LOCALIZE->getPhrase('add_room_error_already_owner', $lang),
						 'title' => $this->LOCALIZE->getPhrase('error', $lang));
		}
		
		$last_login = time();
		
		$this->DB->query("UPDATE rooms 
		                  SET c_id = '$c_id',
						  	  name = '$name', 
						      owner = '$owner_id',
							  active = '$active', 
							  max_users = '$max_users', 
						      payment_type = '$payment_type', 
							  price = '$price', 
							  password = '$password', 
							  temporary = '$temporary',
							  comment = '$comment',
							  last_login = '$last_login',
							  description = '$description',
							  groups = '$groups'
						  WHERE id = '$id';");
		
		$getdata = $this->DB->query("SELECT * FROM rooms WHERE id = '$id' LIMIT 1;");
		$section = $this->DB->fetch_array($getdata);
		$creation = $section['join_date'];
		
		if ($params['ads'] == 1 && $c_id == 0) $this->allowAdvertising($id);
		
		return array('valid' => true, 'time' => $last_login, 'creation' => $creation);
		
	}
	
	function addCategory($params) {
		
		$name = addslashes($params['name']);
		$active = $params['active'];
		$description = addslashes($params['description']);
		$groups = $params['groups'];
		
		$lang = $this->LOCALIZE->checkLanguage($params['lang']);
		
		$join_date = time();
		
		//******* ,       
		$getdata = $this->DB->query("SELECT id FROM rooms WHERE name = '$name' LIMIT 1;");
		$rows = $this->DB->get_num_rows();
		if ($rows != 0) {
			return array('valid' => false, 
						 'error' => $this->LOCALIZE->getPhrase('add_room_error_name_exists', $lang),
						 'title' => $this->LOCALIZE->getPhrase('error', $lang));
		}
		
		$this->DB->query("INSERT INTO rooms (name, rtype, active, description, join_date, groups) 
						  VALUES('$name', 'c', '$active', '$description', '$join_date', '$groups');");
		
		if ($params['ads'] == 1) $this->allowAdvertising($this->DB->insert_id());
		
		return array('valid' => true);
		
	}
	
	function editCategory($params) {
		
		$id = $params['id'];
		$name = addslashes($params['name']);
		$active = $params['active'];
		$description = addslashes($params['description']);
		$groups = $params['groups'];
		
		$lang = $this->LOCALIZE->checkLanguage($params['lang']);
		
		$join_date = time();
		
		//******* ,       
		$getdata = $this->DB->query("SELECT id FROM rooms WHERE name = '$name' AND id <> '$id' LIMIT 1;");
		$rows = $this->DB->get_num_rows();
		if ($rows != 0) {
			return array('valid' => false, 
						 'error' => $this->LOCALIZE->getPhrase('add_room_error_name_exists', $lang),
						 'title' => $this->LOCALIZE->getPhrase('error', $lang));
		}
		
		$this->DB->query("UPDATE rooms 
		                  SET name = '$name', 
							  active = '$active', 
							  description = '$description',
							  groups = '$groups'
						  WHERE id = '$id';");
		
		if ($params['ads'] == 1) $this->allowAdvertising($id);
		
		return array('valid' => true);
		
	}
	
	function remove($room_id) {
		$this->DB->query("DELETE FROM rooms WHERE id = '$room_id';");
		$this->DB->query("DELETE FROM rooms WHERE c_id = '$room_id';");
		$this->DB->query("DELETE FROM ads_room WHERE room_id = '$room_id';");
		$this->DB->query("DELETE FROM users_history WHERE id = '$room_id';");
		$this->DB->query("DELETE FROM users_session WHERE id = '$room_id';");
		return true;
	}
	
	function getRoomData($room_id) {
		
		$getdata = $this->DB->query("SELECT * FROM rooms WHERE id = '$room_id'");
		$section = $this->DB->fetch_array($getdata);
		
		$room = array('id' => $section['id'], 
					  'name' => $section['name'],
					  'user_count' => $section['user_count'],
					  'max_users' => $section['max_users'], 
					  'description' => $section['description'], 
					  'active' => $section['active'] == 1 ? true : false, 
					  'lock' => $section['password'] != "" ? true : false);
			
        return $room;
		
    }
	
	function setRoomCount($room_id, $user_count) {
		$this->DB->query("UPDATE rooms SET user_count = '$user_count', last_login = UNIX_TIMESTAMP() WHERE id = '$room_id';");
		return true;
	}
	
	function entranceToRoom($room_id, $password, $lang = NULL) {
		
		$lang = $this->LOCALIZE->checkLanguage($lang);
		
		$password = md5($password);
		
		$getdata = $this->DB->query("SELECT id FROM rooms WHERE id = '$room_id' AND password = '$password' LIMIT 1; ");
		$rows = $this->DB->get_num_rows($getdata);	
		$section = $this->DB->fetch_array($getdata);	
		
		$id = $section['id'];
		
		if ($id == "") {
			$result = array('valid' => false, 
							'error' => $this->LOCALIZE->getPhrase('server_rooms_error_password', $lang),
							'title' => $this->LOCALIZE->getPhrase('alert', $lang));
			return $result;
		}
		
		$result = array('id' => $id, 'valid' => true);
		
		return $result;
		
	}
	
	function getLastMessages($room_id) {
		$last = time() - 3600;
		//$messages[] = array();
		$getdata = $this->DB->query("SELECT * FROM (SELECT * FROM users_history WHERE room_id = '$room_id' AND time > $last ORDER BY time DESC LIMIT 20) temptablename ORDER BY time ASC;");
		while($section = $this->DB->fetch_array($getdata)) {
			$messages[] = array('author' => $section['user_name'], 
				                'message' => $section['message'], 
								'date' => date("H:i:s", $section['time']));
		}
		return $messages;
	}
	
	function setSnapshot($room_id, $str) {
		$this->DB->query("UPDATE rooms SET snapshot = '$str' WHERE id = '$room_id';");
		return true;
	}
	
	/*
	*
	* Message History
	*
	*/
	
	function getHistory($room_id, $page) {
		
		$count = 20;
		$start = ($page - 1) * $count;
		$add = "";
		
		$getdata = $this->DB->query("SELECT * FROM users_history WHERE room_id = $room_id ORDER BY time DESC LIMIT $start, $count;");
									 
		while($section = $this->DB->fetch_array($getdata)) {
			$messages[] = array('author' => $section['user_name'],
							    'message' => $section['message'],	
							    'snapshot' => $section['snapshot'],
							    'time' => $section['time']);
		}
		
		$getdata = $this->DB->query("SELECT COUNT(*) AS count FROM users_history WHERE room_id = $room_id;");
		$section = $this->DB->fetch_array($getdata);
		$total = $section['count'];
		
		return array('data' => $messages, 'total' => ceil($total/$count), 'current' => $page, 'count' => $total);
		
	}
	
	/*
	*
	* Allow advertising
	*
	*/
	
	function allowAdvertising($room_id) {
		$this->DB->query("DELETE FROM ads_room WHERE room_id = '$room_id';");
		$getdata = $this->DB->query("SELECT id FROM ads_baners;");
		while($section = $this->DB->fetch_array($getdata)) {
			$banner_id = $section['id'];
			$this->DB->query("INSERT INTO ads_room (banner_id, room_id) VALUES('$banner_id', '$room_id');");
		}
	}
	
}
?>